/**
   A simple generic List abstract data type.

   Our textbook never clearly defines a List abstract
   data type. The closest it comes is Section 4.3 and
   Appendix E.

   The List ADT is very important in computer science.
   It is the fundamental data structure for many programming
   languages (Python, JavaScript, Lisp, Scheme).

   This List ADT is similar to lists in Scheme and Lisp.

   Here is what the List interface adds to the Container interface.
      public T getFirst();
      public T remove();
*/

public abstract class List<T> extends Container<T>
{
   protected List()
   {
       super("[", "]");
   }

   public abstract T getFirst();

   public abstract T remove();

}//List
