/**
   A simple test of the iterable, generic, List data type.
*/
import java.util.Comparator;

public class TestList
{
   public static void main(String[] args)
   {
      // Notice how myList is a List reference to a LinkedList object.
      List<Integer> myList = new LinkedList<Integer>();

      myList.add(1);
      myList.add(2);
      myList.add(3);
      myList.add(10);
      myList.add(4);
      myList.add(5);
      myList.add(6);

      System.out.println( "length = " + myList.size() );

      System.out.println( myList );

      for ( Integer i : myList )
      {
         System.out.println( i );
      }

      System.out.println("The maximum element is = " + Container.max(myList) );


      System.out.println( );


      // Notice how myList is a List reference to a ArrayList object.
      myList = new ArrayList<Integer>();

      myList.add(10);
      myList.add(20);
      myList.add(30);
      myList.add(100);
      myList.add(40);
      myList.add(50);
      myList.add(60);

      System.out.println( "length = " + myList.size() );

      System.out.println( myList );

      for ( Integer i : myList )
      {
         System.out.println( i );
      }

      System.out.println("The maximum element is = " + Container.max(myList) );


      System.out.println( );


      // Notice how myList2 is a List reference to a LinkedList object.
      List<String> myList2 = new LinkedList<String>();

      myList2.add("aardvark");
      myList2.add("cat");
      myList2.add("dog");
      myList2.add("elephant");
      myList2.add("zebra");
      myList2.add("lion");
      myList2.add("tiger");

      System.out.println( "length = " + myList2.size() );

      System.out.println( myList2 );

      for ( String s : myList2 )
      {
         System.out.println( s );
      }

      System.out.println("The maximum element is = " + Container.max(myList2) );
      System.out.println("The maximum element is = " + Container.max(myList2, new StringCmp()) );
   }
}



/*
   Here is a different way to compare strings,
   by their length.
*/
class StringCmp implements Comparator<String>
{
   public int compare(String s1, String s2)
   {
      return ( s1.length() - s2.length() );
   }
}
